#ifndef __COMMON_H__
#define __COMMON_H__

#include "config.h"
#include <string>
#include <sstream>
#include <iomanip>

#ifndef WIN32
#define HAVE_RINT
#endif


#ifndef HAVE_RINT

#include <cmath>
   inline int rint(double f)
   { 
      return (int) (f-std::floor(f)<0.5?std::floor(f):std::ceil(f));
   }

#endif

enum ListType
{
   LtUndefined,
   LtBulleted,
   LtNumbered
};

inline std::string from_int(int value)
{
   std::ostringstream buf;
   buf<<value;
   return buf.str();
}

inline std::string hex(unsigned int value)
{
   std::ostringstream buf;
   buf<<std::setw(2)<<std::setfill('0')<<std::hex<<value;
   return buf.str();
}

inline void str_replaceAll(std::string& str, const std::string& from, const std::string& to) {
   if(from.empty())
      return;
   size_t start_pos = 0;
   while((start_pos = str.find(from, start_pos)) != std::string::npos) {
      str.replace(start_pos, from.length(), to);
      start_pos += to.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'
   }
}

#endif
